/**************************************************************************

	nLaunch

	file.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <shlobj.h>

#include "general.h"
#include "file.h"

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE				256							/* obt@TCY */
#define SORT_FILENAME			"nLaunch.lst"				/* яۑt@C */

#define ToLower(c)				((c >= 'A' && c <= 'Z') ? (c - 'A' + 'a') : c)


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static BOOL StrMatch(const char *Ptn, const char *Str);
static BOOL ChkFilter(char *Ptn, char *Str);


/******************************************************************************

	FileSelect

	t@CI

******************************************************************************/

int FileSelect(const HWND hDlg, char *ret)
{
	OPENFILENAME of;

	lstrcpy(ret,"*.bmp");
	ZeroMemory(&of, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	of.hwndOwner = hDlg;
	of.lpstrFilter = "rbg}bv (*.bmp)\0*.bmp\0\0";
	of.lpstrTitle = "t@CI";
	of.lpstrFile = ret;
	of.lpstrDefExt = "bmp";
	of.nMaxFile = BUF_SIZE - 1;
	of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

	/* t@CI_CAO\ */
	if(GetOpenFileName((LPOPENFILENAME)&of) == TRUE){
		return of.nFilterIndex;
	}
	return -1;
}


/******************************************************************************

	FolderSelect

	tH_I

******************************************************************************/

BOOL FolderSelect(const HWND hWnd, char *ret)
{
	BROWSEINFO typBROWSEINFO;
	LPITEMIDLIST lpItemList;
	char buf[BUF_SIZE];

	typBROWSEINFO.hwndOwner = hWnd;
	typBROWSEINFO.pidlRoot = (const struct _ITEMIDLIST *)CSIDL_DESKTOP;
	*buf = '\0';
	typBROWSEINFO.pszDisplayName = buf;
	typBROWSEINFO.lpszTitle = "tH_IĂ";
	typBROWSEINFO.ulFlags = BIF_RETURNONLYFSDIRS;	/* tH_͑IłȂ悤ɂ */
	typBROWSEINFO.lpfn = NULL;
	typBROWSEINFO.lParam = 0;
	typBROWSEINFO.iImage = 0;

	/* tH_Iʂ\ */
	lpItemList = SHBrowseForFolder(&typBROWSEINFO);
	if(lpItemList == NULL){
		return FALSE;
	}
	/* IĂtH_̃tpX擾 */
	SHGetPathFromIDList(lpItemList, ret);
	return TRUE;
}


/******************************************************************************

	ConvFilename

	t@CɂłȂ _ ɕϊ

******************************************************************************/

void ConvFilename(char *buf)
{
	char *p = buf;

	while(*p != '\0'){
		if(IsDBCSLeadByte(*p) == TRUE){
			/* QoCgR[h̏ꍇ */
			p++;

		}else{
			/* t@CɂłȂ͎w̕ɕϊ */
			switch(*p)
			{
			case '\\': case '/': case ':':
			case ',': case ';': case '*':
			case '?': case '\"': case '<':
			case '>': case '|':
				*p = '_';
				break;
			}
		}
		p++;
	}
}


/******************************************************************************

	GetDirectory

	t@CpXfBNgpX̎擾

******************************************************************************/

void GetDirectory(char *buf)
{
	char *p, *r;

	for(r = p = buf; *p != '\0'; p++){
		if(IsDBCSLeadByte(*p) == TRUE){
			p++;
			continue;
		}
		if(*p == '\\'){
			r = p;
		}
	}
	*r = '\0';
}


/******************************************************************************

	GetStrLen

	rp̒̕擾

******************************************************************************/

static int GetStrLen(const char *buf, int len)
{
	int i;

	if(len < 0) return len;

	for(i = 0; i < len; i++){
		if(*buf == '\0'){
			break;
		}
		buf++;
	}
	return i;
}


/******************************************************************************

	StrCmpNI

	̑啶ʂȂrs

******************************************************************************/

static int StrCmpNI(const char *buf1, const char *buf2, int len)
{
	int ret;
	int len1, len2;

	len1 = GetStrLen(buf1, len);
	len2 = GetStrLen(buf2, len);

	ret = CompareString(MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), SORT_DEFAULT),
		NORM_IGNORECASE, buf1, len1, buf2, len2);
	return ret - 2;
}


/******************************************************************************

	StrMatch

	Q̕ChJ[h(*)gĔrs

******************************************************************************/

static BOOL StrMatch(const char *Ptn, const char *Str)
{
	switch(*Ptn)
	{
		case '\0':
			return (*Str == '\0');
		case '*':
			return StrMatch(Ptn + 1, Str) || (*Str != '\0') && StrMatch(Ptn, Str + 1);
		case '?':
			return (*Str != '\0') && StrMatch(Ptn + 1, Str + 1);
		default:
			return (ToLower(*Ptn) == ToLower(*Str)) && StrMatch(Ptn + 1, Str + 1);
	}
}


/******************************************************************************

	ChkFilter

	tB^[Ƀ}b`邩`FbN

******************************************************************************/

static BOOL ChkFilter(char *Ptn, char *Str)
{
	char ret[BUF_SIZE];
	char *p = Ptn, *r;

	while(1){
		for(r = ret; *p != ',' && *p != ';' && *p != '\0';p++, r++){
			*r = *p;
		}
		*r = '\0';

		/* ̃`FbN */
		if(StrMatch(ret, Str) == TRUE){
			return TRUE;
		}

		if(*p == '\0'){
			break;
		}
		p++;
		for(; *p == ' '; p++);
	}
	return FALSE;
}


/******************************************************************************

	CreateFileList

	t@C̈ꗗ쐬

******************************************************************************/

int CreateFileList(char *path, char *filter, int ftype, int sdir, FILELIST **FileList, int cnt)
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;
	char sPath[BUF_SIZE];
	int ret;

	/*  */
	FreeFileList(*FileList, cnt);
	*FileList = NULL;

	if(*path == '\0') return 0;

	/* 镶̍쐬 */
	wsprintf(sPath, "%s\\*", path);

	/* t@C̐JEg */
	if((hFindFile = FindFirstFile(sPath, &FindData)) == INVALID_HANDLE_VALUE){
		return 0;
	}
	ret = 0;
	do{
		if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			if(sdir == 0 ||
				lstrcmp(FindData.cFileName, ".") == 0 || lstrcmp(FindData.cFileName, "..") == 0){
				continue;
			}
		}else{
			/* tB^̃`FbN */
			if(ChkFilter(filter, FindData.cFileName) == TRUE){
				if(ftype == 1) continue;
			}else{
				if(ftype == 0) continue;
			}
		}
		ret++;
	} while(FindNextFile(hFindFile, &FindData) == TRUE);
	FindClose(hFindFile);

	/* t@C̃Xgm */
	*FileList = (FILELIST *)LocalAlloc(LMEM_FIXED, sizeof(FILELIST) * (ret + 1));
	if(*FileList == NULL){
		return 0;
	}
	(*FileList)->FileName = NULL;
	(*FileList)->ImageIndex = 0;

	/* t@C̃Xg̍쐬 */
	if((hFindFile = FindFirstFile(sPath, &FindData)) == INVALID_HANDLE_VALUE){
		LocalFree(*FileList);
		*FileList = NULL;
		return 0;
	}
	ret = 1;
	do{
		if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			if(sdir == 0 ||
				lstrcmp(FindData.cFileName, ".") == 0 || lstrcmp(FindData.cFileName, "..") == 0){
				continue;
			}
		}else{
			/* tB^̃`FbN */
			if(ChkFilter(filter, FindData.cFileName) == TRUE){
				if(ftype == 1) continue;
			}else{
				if(ftype == 0) continue;
			}
		}
		(*FileList + ret)->FileName = (char *)LocalAlloc(LMEM_FIXED, lstrlen(FindData.cFileName) + 1);
		if((*FileList + ret)->FileName != NULL){
			lstrcpy((*FileList + ret)->FileName, FindData.cFileName);
		}
		(*FileList + ret)->ImageIndex = ret;
		ret++;
	} while(FindNextFile(hFindFile, &FindData) == TRUE);
	FindClose(hFindFile);
	return ret;
}


/******************************************************************************

	FreeFileList

	t@Cꗗ̉

******************************************************************************/

void FreeFileList(FILELIST *FileList, int cnt)
{
	int i;

	if(FileList != NULL){
		for(i = 0; i < cnt; i++){
			if((FileList + i)->FileName != NULL){
				LocalFree((FileList + i)->FileName);
			}
		}
		LocalFree(FileList);
	}
}


/******************************************************************************

	MoveFileList

	wʒũt@Cړ

******************************************************************************/

void MoveFileList(FILELIST *FileList, int to, int from)
{
	FILELIST p;
	int i;

	p = *(FileList + from);
	for(i = from; i > to; i--){
		*(FileList + i) = *(FileList + i - 1);
	}
	*(FileList + to) = p;
}


/******************************************************************************

	FindFileList

	t@C̓CfbNX

******************************************************************************/

int FindFileList(FILELIST *FileList, int cnt, int index, char c)
{
	int i;

	for(i = index + 1; i < cnt; i++){
		if((FileList + i)->FileName == NULL){
			continue;
		}
		if(ToLower(*((FileList + i)->FileName)) == ToLower(c)){
			return i;
		}
	}
	for(i = 1; i <= index; i++){
		if((FileList + i)->FileName == NULL){
			continue;
		}
		if(ToLower(*((FileList + i)->FileName)) == ToLower(c)){
			return i;
		}
	}
	return -1;
}


/******************************************************************************

	RestoreFileList

	t@Cꗗ̕я𕜌

******************************************************************************/

BOOL RestoreFileList(char *path, FILELIST *FileList, int cnt)
{
	HANDLE hFile;
	char FilePath[BUF_SIZE];
	char *buf, *p;
	DWORD fSizeLow, fSizeHigh;
	DWORD ret;
	int index, i;

	if(FileList == NULL){
		return TRUE;
	}

	/* t@CJ */
	wsprintf(FilePath, "%s\\"SORT_FILENAME, path);
	hFile = CreateFile(FilePath, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == NULL){
		return FALSE;
	}
	fSizeLow = GetFileSize(hFile, &fSizeHigh);
	if(fSizeLow == 0xFFFFFFFF){
		CloseHandle(hFile);
		return FALSE;
	}

	/* t@C̓eǂݍ */
	buf = (char *)LocalAlloc(LPTR, fSizeLow + 1);
	if(buf == NULL){
		CloseHandle(hFile);
		return FALSE;
	}
	if(ReadFile(hFile, buf, fSizeLow, &ret, NULL) == FALSE){
		LocalFree(buf);
		CloseHandle(hFile);
		return FALSE;
	}
	CloseHandle(hFile);

	/* t@Cꗗƕя}[W */
	index = 1;
	p = buf;
	while(*p != '\0' && index < cnt){
		for(i = index; i < cnt; i++){
			if((FileList + i)->FileName != NULL &&
				StrCmpNI((FileList + i)->FileName, p, lstrlen((FileList + i)->FileName)) == 0){
				MoveFileList(FileList, index, i);
				index++;
				break;
			}
		}
		for(;*p != '\0' && *p != '\r' && *p != '\n'; p++);
		for(;*p == '\r' || *p == '\n'; p++);
	}
	LocalFree(buf);
	return TRUE;
}


/******************************************************************************

	SaveFileList

	t@Cꗗ̕яۑ

******************************************************************************/

BOOL SaveFileList(char *path, FILELIST *FileList, int cnt)
{
	HANDLE hFile;
	char FilePath[BUF_SIZE];
	DWORD ret;
	int i;

	if(FileList == NULL){
		return TRUE;
	}
	wsprintf(FilePath, "%s\\"SORT_FILENAME, path);

	/* t@CJ */
	hFile = CreateFile(FilePath, GENERIC_READ | GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == NULL || hFile == (HANDLE)-1){
		return FALSE;
	}

	/* t@Cꗗ̕яۑ */
	for(i = 0; i < cnt; i++){
		if((FileList + i)->FileName != NULL){
			if(WriteFile(hFile, (FileList + i)->FileName, lstrlen((FileList + i)->FileName), &ret, NULL) == FALSE){
				CloseHandle(hFile);
				return FALSE;
			}
			if(WriteFile(hFile, "\r\n", 2, &ret, NULL) == FALSE){
				CloseHandle(hFile);
				return FALSE;
			}
		}
	}
	CloseHandle(hFile);
	return TRUE;
}
/* End of source */
