/**************************************************************************

	nLaunch

	image.h

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

#ifndef _INC_IMAGE_H
#define _INC_IMAGE_H

/**************************************************************************
	Include
**************************************************************************/

#include "general.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE				256

typedef enum _POSINFO {
	POS_WINDOW = 0,
	POS_FRAME,
	POS_TRANSCOLOR,
	POS_ICON,
	POS_ICONCOUNT,
	POS_ICONWIDTH,
	POS_ICONLEFT,
	POS_ICONTOP,
	POS_SELICON,
	POS_SELICONFRAME,
	POS_TITLEBAR,
	POS_TITLETEXT,
	POS_TEXTLEFT,
	POS_TEXTRIGHT,
	POS_TEXTTOP,

	POS_ICONINDEX = 100
} POSINFO;


/**************************************************************************
	Struct
**************************************************************************/

/* ` */
typedef struct _PAINTINFO {
	/* pl */
	HDC hPanelDC;
	HBITMAP hPanelBmp;
	HBITMAP hRetPanelBmp;
	/* wi */
	HDC hBackDC;
	HBITMAP hBackBmp;
	HBITMAP hRetBackBmp;
	/* ^Cg */
	HDC hTitleDC;
	HBITMAP hTitleBmp;
	HBITMAP hRetTitleBmp;
	/* tHg */
	HFONT hFont;
	HFONT hRetFont;

	/* ACR̍F */
	long TransColor;
	/* EBhE̕ */
	int WindowWidth;
	/* ^Cgo[̍ */
	int TitleHeight;

	/* INI */
	char Background[BUF_SIZE];
	int BackPaintMode;
	char FocusBitmap[BUF_SIZE];
	int FocusPaintMode;
	char Titlebar[BUF_SIZE];
	int TitlePaintMode;
	int FlatWindow;
	int WindowsDef;
	int TransparentWindow;
	int ShowTitle;
	int DownTitle;
	int CenterText;

	int WindowHeight;
	int FrameSize;
	int IconSize;
	int IconCount;
	int IconTop;
	int IconWidth;
	int IconLeft;
	int FocusSize;
	int FocusFrameSize;
	int TitleSize;
	int TitleTextLeft;
	int TitleTextRight;
	int TitleTextTop;

	long WindowColor;
	long FrameColor;
	long TransparentColor;
	long FocusBackColor;
	long FocusFrameColor;
	long TitleColor;
	long TitleTextColor;

	char FontName[BUF_SIZE];		/* tHg */
	char FontStyle[BUF_SIZE];		/* tHgX^C */
	int FontItalic;					/* Α */
	int FontHeight;					/* tHg̍ */
	int FontWeight;					/* tHg̑ */
} PAINTINFO;

typedef struct _DRAWINFO {
	/* pl */
	HDC hPanelDC;
	HBITMAP hPanelBmp;
	HBITMAP hRetPanelBmp;
	/* wi */
	HDC hBackDC;
	HBITMAP hBackBmp;
	HBITMAP hRetBackBmp;
	/* ^Cg */
	HDC hTitleDC;
	HBITMAP hTitleBmp;
	HBITMAP hRetTitleBmp;
	/* tHg */
	HFONT hFont;
	HFONT hRetFont;
} DRAWINFO;


/**************************************************************************
	Function Prototypes
**************************************************************************/

void SetImegeListIcon(char *path, FILELIST *FileList, int IconCnt, int IconSize, PAINTINFO *pi);
void EndImegeListIcon(void);
int GetTitleSize(PAINTINFO *pi);
void _TransparentBlt(HDC todc, int left, int top, int width, int height,
					HDC fromdc, int fleft, int ftop, COLORREF color);
void InitPanel(PAINTINFO *pi);
void EndPanel(PAINTINFO *pi);
void SetIconPanel(HWND hWnd, PAINTINFO *pi, FILELIST *FileList, int ViewIndex, int ViewPos);
int PanelHitTest(PAINTINFO *pi, int x, int y, int ViewIndex);
HRGN CreateBmpRgn(HBITMAP hbmp, COLORREF color, int FrameWidth, int FrameHeight);

#endif

/* End of source */
