/**************************************************************************

	nLaunch

	ini.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "image.h"
#include "ini.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE				256							/* obt@TCY */


/**************************************************************************
	Global Variables
**************************************************************************/

char launch_path[BUF_SIZE];
char filterPtn[BUF_SIZE];
int filterType;
int ShowDir;

int ShowModKey;
char ShowVKey;
int BackModKey;
char BackVKey;

int MoveTop;
int UseMouse;
int FindChar;
int LeftPos;
int TopPos;
int TransparentIcon;

int MoveSpeed;

int Layerer;
int LayererAlpha;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static long x2d(const char *str);
static BOOL WritePrivateProfileInt(char *lpszSection, char *lpszKey, char *fmt, int num, char *lpszFile);


/******************************************************************************

	x2d

	16i\L̕𐔒lɕϊ

******************************************************************************/

static long x2d(const char *str)
{
	int num = 0;
	int m;

	if(!(*str == '0' && (*(str + 1) == 'x' || *(str + 1) == 'X'))){
		return atol(str);
	}
	for(str += 2; *str != '\0'; str++){
		if(*str >= '0' && *str <= '9'){
			m = *str - '0';
		}else if(*str >= 'A' && *str <= 'F'){
			m = *str - 'A' + 10;
		}else if(*str >= 'a' && *str <= 'f'){
			m = *str - 'a' + 10;
		}else{
			break;
		}
		num = 16 * num + m;
	}
	return num;
}


/******************************************************************************

	WritePrivateProfileInt

	lINIt@Cɕۑ

******************************************************************************/

static BOOL WritePrivateProfileInt(char *lpszSection, char *lpszKey, char *fmt, int num, char *lpszFile)
{
	char buf[BUF_SIZE];

	wsprintf(buf, fmt, num);
	return WritePrivateProfileString(lpszSection, lpszKey, buf, lpszFile);
}


/******************************************************************************

	GetOptionIni

	Ɋւݒǂݍ

******************************************************************************/

void GetOptionIni(char *path)
{
	OSVERSIONINFO os_info;
	char buf[BUF_SIZE];

	GetPrivateProfileString("OPTION", "LaunchPath", "", launch_path, BUF_SIZE - 1, path);
	filterType = GetPrivateProfileInt("OPTION", "filterType", 0, path);
	GetPrivateProfileString("OPTION", "filterPtn", "*.exe;*.lnk;*.url", filterPtn, BUF_SIZE - 1, path);
	ShowDir = GetPrivateProfileInt("OPTION", "ShowDir", 1, path);

	ShowModKey = GetPrivateProfileInt("OPTION", "ShowModKey", 1, path);
	GetPrivateProfileString("OPTION", "ShowVKey", "Q", buf, BUF_SIZE - 1, path);
	ShowVKey = *buf;
	BackModKey = GetPrivateProfileInt("OPTION", "BackModKey", 5, path);
	GetPrivateProfileString("OPTION", "BackVKey", "Q", buf, BUF_SIZE - 1, path);
	BackVKey = *buf;

	MoveTop = GetPrivateProfileInt("OPTION", "MoveTop", 1, path);
	UseMouse = GetPrivateProfileInt("OPTION", "UseMouse", 0, path);
	FindChar = GetPrivateProfileInt("OPTION", "FindChar", 1, path);
	LeftPos = GetPrivateProfileInt("OPTION", "LeftPos", 0, path);
	TopPos = GetPrivateProfileInt("OPTION", "TopPos", 0, path);
	TransparentIcon = GetPrivateProfileInt("OPTION", "TransparentIcon", 1, path);

	os_info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&os_info);
	MoveSpeed = GetPrivateProfileInt("OPTION", "MoveSpeed",
		((os_info.dwPlatformId == VER_PLATFORM_WIN32_NT) ? 8 : 28), path);

	Layerer = GetPrivateProfileInt("OPTION", "Layerer", 0, path);
	LayererAlpha = GetPrivateProfileInt("OPTION", "LayererAlpha", 200, path);
}


/******************************************************************************

	PutOptionIni

	Ɋւݒ

******************************************************************************/

void PutOptionIni(char *path)
{
	char buf[BUF_SIZE];

	WritePrivateProfileString("OPTION", "LaunchPath", launch_path, path);
	WritePrivateProfileInt("OPTION", "filterType", "%d", filterType, path);
	WritePrivateProfileString("OPTION", "filterPtn", filterPtn, path);
	WritePrivateProfileInt("OPTION", "ShowDir", "%d", ShowDir, path);

	WritePrivateProfileInt("OPTION", "ShowModKey", "%d", ShowModKey, path);
	*buf = ShowVKey;
	*(buf + 1) = '\0';
	WritePrivateProfileString("OPTION", "ShowVKey", buf, path);
	WritePrivateProfileInt("OPTION", "BackModKey", "%d", BackModKey, path);
	*buf = BackVKey;
	*(buf + 1) = '\0';
	WritePrivateProfileString("OPTION", "BackVKey", buf, path);

	WritePrivateProfileInt("OPTION", "MoveTop", "%d", MoveTop, path);
	WritePrivateProfileInt("OPTION", "UseMouse", "%d", UseMouse, path);
	WritePrivateProfileInt("OPTION", "FindChar", "%d", FindChar, path);
	WritePrivateProfileInt("OPTION", "LeftPos", "%d", LeftPos, path);
	WritePrivateProfileInt("OPTION", "TopPos", "%d", TopPos, path);
	WritePrivateProfileInt("OPTION", "TransparentIcon", "%d", TransparentIcon, path);

	WritePrivateProfileInt("OPTION", "MoveSpeed", "%d", MoveSpeed, path);

	WritePrivateProfileInt("OPTION", "Layerer", "%d", Layerer, path);
	WritePrivateProfileInt("OPTION", "LayererAlpha", "%d", LayererAlpha, path);
}


/******************************************************************************

	GetWindowIni

	\Ɋւݒǂݍ

******************************************************************************/
void GetWindowIni(char *path, PAINTINFO *pi)
{
	char buf[BUF_SIZE];

	GetPrivateProfileString("WINDOW", "Background", "", pi->Background, BUF_SIZE - 1, path);
	pi->BackPaintMode = GetPrivateProfileInt("WINDOW", "BackPaintMode", 0, path);
	GetPrivateProfileString("WINDOW", "FocusBitmap", "", pi->FocusBitmap, BUF_SIZE - 1, path);
	pi->FocusPaintMode = GetPrivateProfileInt("WINDOW", "FocusPaintMode", 0, path);
	GetPrivateProfileString("WINDOW", "Titlebar", "", pi->Titlebar, BUF_SIZE - 1, path);
	pi->TitlePaintMode = GetPrivateProfileInt("WINDOW", "TitlePaintMode", 0, path);
	pi->FlatWindow = GetPrivateProfileInt("WINDOW", "FlatWindow", 0, path);
	pi->WindowsDef = GetPrivateProfileInt("WINDOW", "WindowsDef", 1, path);
	pi->TransparentWindow = GetPrivateProfileInt("WINDOW", "TransparentWindow", 0, path);
	pi->ShowTitle = GetPrivateProfileInt("WINDOW", "ShowTitle", 1, path);
	pi->DownTitle = GetPrivateProfileInt("WINDOW", "DownTitle", 0, path);
	pi->CenterText = GetPrivateProfileInt("WINDOW", "CenterText", 0, path);

	pi->WindowHeight = GetPrivateProfileInt("SIZE", "WindowHeight", 60, path);
	pi->FrameSize = GetPrivateProfileInt("SIZE", "FrameSize", 1, path);
	pi->IconSize = GetPrivateProfileInt("SIZE", "IconSize", 32, path);
	pi->IconCount = GetPrivateProfileInt("SIZE", "IconCount", 6, path);
	pi->IconLeft = GetPrivateProfileInt("SIZE", "IconLeft", 0, path);
	pi->IconWidth = GetPrivateProfileInt("SIZE", "IconWidth", 56, path);
	pi->IconTop = GetPrivateProfileInt("SIZE", "IconTop", 14, path);
	pi->FocusSize = GetPrivateProfileInt("SIZE", "FocusSize", 46, path);
	pi->FocusFrameSize = GetPrivateProfileInt("SIZE", "FocusFrameSize", 1, path);
	pi->TitleSize = GetPrivateProfileInt("SIZE", "TitleSize", 16, path);
	pi->TitleTextLeft = GetPrivateProfileInt("SIZE", "TitleTextLeft", 2, path);
	pi->TitleTextRight = GetPrivateProfileInt("SIZE", "TitleTextRight", 2, path);
	pi->TitleTextTop = GetPrivateProfileInt("SIZE", "TitleTextTop", 0, path);

	GetPrivateProfileString("COLOR", "WindowColor", "0xC0C0C0", buf, BUF_SIZE - 1, path);
	pi->WindowColor = x2d(buf);
	GetPrivateProfileString("COLOR", "FrameColor", "0xC0C0C0", buf, BUF_SIZE - 1, path);
	pi->FrameColor = x2d(buf);
	GetPrivateProfileString("COLOR", "TransparentColor", "0xFF00FF", buf, BUF_SIZE - 1, path);
	pi->TransparentColor = x2d(buf);
	GetPrivateProfileString("COLOR", "FocusBackColor", "0xFFFFFF", buf, BUF_SIZE - 1, path);
	pi->FocusBackColor = x2d(buf);
	GetPrivateProfileString("COLOR", "FocusFrameColor", "0x000000", buf, BUF_SIZE - 1, path);
	pi->FocusFrameColor = x2d(buf);
	GetPrivateProfileString("COLOR", "TitleColor", "0x800000", buf, BUF_SIZE - 1, path);
	pi->TitleColor = x2d(buf);
	GetPrivateProfileString("COLOR", "TitleTextColor", "0xFFFFFF", buf, BUF_SIZE - 1, path);
	pi->TitleTextColor = x2d(buf);

	GetPrivateProfileString("FONT", "FontName", "lr oSVbN", pi->FontName, BUF_SIZE - 1, path);
	GetPrivateProfileString("FONT", "FontStyle", "W", pi->FontStyle, BUF_SIZE - 1, path);
	pi->FontItalic = GetPrivateProfileInt("FONT", "FontItalic", 0, path);
	pi->FontHeight = GetPrivateProfileInt("FONT", "FontHeight", 9, path);
	pi->FontWeight = GetPrivateProfileInt("FONT", "FontWeight", 0, path);

}


/******************************************************************************

	PutWindowIni

	\Ɋւݒۑ

******************************************************************************/

void PutWindowIni(char *path, PAINTINFO *pi)
{
	WritePrivateProfileString("WINDOW", "Background", pi->Background, path);
	WritePrivateProfileInt("WINDOW", "BackPaintMode", "%d", pi->BackPaintMode, path);
	WritePrivateProfileString("WINDOW", "FocusBitmap", pi->FocusBitmap, path);
	WritePrivateProfileInt("WINDOW", "FocusPaintMode", "%d", pi->FocusPaintMode, path);
	WritePrivateProfileString("WINDOW", "Titlebar", pi->Titlebar, path);
	WritePrivateProfileInt("WINDOW", "TitlePaintMode", "%d", pi->TitlePaintMode, path);

	WritePrivateProfileInt("WINDOW", "FlatWindow", "%d", pi->FlatWindow, path);
	WritePrivateProfileInt("WINDOW", "WindowsDef", "%d", pi->WindowsDef, path);
	WritePrivateProfileInt("WINDOW", "TransparentWindow", "%d", pi->TransparentWindow, path);
	WritePrivateProfileInt("WINDOW", "ShowTitle", "%d", pi->ShowTitle, path);
	WritePrivateProfileInt("WINDOW", "DownTitle", "%d", pi->DownTitle, path);
	WritePrivateProfileInt("WINDOW", "CenterText", "%d", pi->CenterText, path);

	WritePrivateProfileInt("SIZE", "WindowHeight", "%d", pi->WindowHeight, path);
	WritePrivateProfileInt("SIZE", "FrameSize", "%d", pi->FrameSize, path);
	WritePrivateProfileInt("SIZE", "IconSize", "%d", pi->IconSize, path);
	WritePrivateProfileInt("SIZE", "IconCount", "%d", pi->IconCount, path);
	WritePrivateProfileInt("SIZE", "IconWidth", "%d", pi->IconWidth, path);
	WritePrivateProfileInt("SIZE", "IconLeft", "%d", pi->IconLeft, path);
	WritePrivateProfileInt("SIZE", "IconTop", "%d", pi->IconTop, path);
	WritePrivateProfileInt("SIZE", "FocusSize", "%d", pi->FocusSize, path);
	WritePrivateProfileInt("SIZE", "FocusFrameSize", "%d", pi->FocusFrameSize, path);
	WritePrivateProfileInt("SIZE", "TitleSize", "%d", pi->TitleSize, path);
	WritePrivateProfileInt("SIZE", "TitleTextLeft", "%d", pi->TitleTextLeft, path);
	WritePrivateProfileInt("SIZE", "TitleTextRight", "%d", pi->TitleTextRight, path);
	WritePrivateProfileInt("SIZE", "TitleTextTop", "%d", pi->TitleTextTop, path);

	WritePrivateProfileInt("COLOR", "WindowColor", "0x%06lX", pi->WindowColor, path);
	WritePrivateProfileInt("COLOR", "FrameColor", "0x%06lX", pi->FrameColor, path);
	WritePrivateProfileInt("COLOR", "TransparentColor", "0x%06lX", pi->TransparentColor, path);
	WritePrivateProfileInt("COLOR", "FocusBackColor", "0x%06lX", pi->FocusBackColor, path);
	WritePrivateProfileInt("COLOR", "FocusFrameColor", "0x%06lX", pi->FocusFrameColor, path);
	WritePrivateProfileInt("COLOR", "TitleColor", "0x%06lX", pi->TitleColor, path);
	WritePrivateProfileInt("COLOR", "TitleTextColor", "0x%06lX", pi->TitleTextColor, path);

	WritePrivateProfileString("FONT", "FontName", pi->FontName, path);
	WritePrivateProfileString("FONT", "FontStyle", pi->FontStyle, path);
	WritePrivateProfileInt("FONT", "FontItalic", "%d", pi->FontItalic, path);
	WritePrivateProfileInt("FONT", "FontHeight", "%d", pi->FontHeight, path);
	WritePrivateProfileInt("FONT", "FontWeight", "%d", pi->FontWeight, path);
	WritePrivateProfileString(NULL, NULL, NULL, path);
}


/******************************************************************************

	DelWindowIni

	\Ɋւݒ폜

******************************************************************************/

void DelWindowIni(char *path)
{
	DeleteFile(path);
}


/******************************************************************************

	EnumWindowIni

	\Ɋւݒ

******************************************************************************/

void EnumWindowIni(HWND hCmb, char *path)
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;
	char sPath[BUF_SIZE];
	char buf[BUF_SIZE];
	char *p, *r;

	wsprintf(sPath, "%s\\*.cfg", path);

	/* t@C̐JEg */
	if((hFindFile = FindFirstFile(sPath, &FindData)) == INVALID_HANDLE_VALUE){
		return;
	}
	do{
		lstrcpy(buf, FindData.cFileName);
		/* gq̏ */
		for(r = NULL, p = buf; *p != '\0'; p++){
			if(IsDBCSLeadByte(*p) == TRUE){
				p++;
				continue;
			}
			if(*p == '.'){
				r = p;
			}
		}
		if(r != NULL) *r = '\0';

		SendMessage(hCmb, CB_ADDSTRING, 0, (LPARAM)buf);

	} while(FindNextFile(hFindFile, &FindData) == TRUE);
	FindClose(hFindFile);
}
/* End of source */
